
function com_zimbra_hideprefsections_HandlerObject() {
}

com_zimbra_hideprefsections_HandlerObject.prototype = new ZmZimletBase();
com_zimbra_hideprefsections_HandlerObject.prototype.constructor = com_zimbra_hideprefsections_HandlerObject;

/**
 * Simplify handler object
 */
var HidePrefZimlet = com_zimbra_hideprefsections_HandlerObject;

/**
 * Initializes the zimlet.
 */
HidePrefZimlet.prototype.init = function() {
  this.overrideAPI(ZmPreferencesApp.prototype, "_registerPrefs", this._hideCustomPrefSections);
};

HidePrefZimlet.prototype._hideCustomPrefSections = function() {
  
    /* call the old code first */
  arguments.callee.func.apply(this);

  /* Remove Trusted Addresses Section from Preferences */
  var p=appCtxt.get(ZmSetting.PREF_SECTIONS,"TRUSTED_ADDR");
  p.precondition = false;

  /* Remove Accounts Section from Preferences */
  p=appCtxt.get(ZmSetting.PREF_SECTIONS,"ACCOUNTS");
  p.precondition = false;

  /* Remove Filters Section from Preferences */
  p=appCtxt.get(ZmSetting.PREF_SECTIONS,"FILTERS");
  p.precondition = false;

  /* Remove Notifications Section from Preferences */
  p=appCtxt.get(ZmSetting.PREF_SECTIONS,"NOTIFICATIONS");
  p.precondition = false;

  /* Remove Zimlets Section from Preferences */
  //p=appCtxt.get(ZmSetting.PREF_SECTIONS,"PREF_ZIMLETS");
  //p.precondition = false;

};

// The overriden function will be saved as the "func" attribute before
// we perform the call to newfunc.
// It may be called as arguments.callee.func from inside the new
// function (A), or as object[funcname].func from other functions (B).
// newfunc may be available to several classes (call overrideAPI on several
// class prototypes), and remain the same shared function object.
// Each time object[funcname] is called, the newfunc.func attribute is set to
// the appropriate overridden function.
HidePrefZimlet.prototype.overrideAPI = function(object, funcname, newfunc) {
    newfunc = newfunc || this[funcname];
    if (newfunc) {
        var oldfunc = object[funcname];
        object[funcname] = function() {
            newfunc.func = oldfunc; // (A)
            return newfunc.apply(this, arguments);
        }
        object[funcname].func = oldfunc; // (B)
    }
};
